## pyroute2 0.6.7

=== Makefile ===
##
#
#   The pyroute2 project is dual licensed, see README.license.md for details
#
#

##
# Python-related configuration
#
python ?= python
nosetests ?= nosetests
flake8 ?= flake8
black ?= black
pytest ?= pytest
##
# Python -W flags:
#
#  ignore  -- completely ignore
#  default -- default action
#  all     -- print all warnings
#  module  -- print the first warning occurence for a module
#  once    -- print each warning only once
#  error   -- fail on any warning
#
#  Would you like to know more? See man 1 python
#
wlevel ?= once

##
# Other options
#
# root      -- install root (default: platform default)
# lib       -- lib installation target (default: platform default)
# coverage  -- whether to produce html coverage (default: false)
# pdb       -- whether to run pdb on errors (default: false)
# module    -- run only the specified test module (default: run all)
#
ifdef root
	override root := "--root=${root}"
endif

ifdef lib
	override lib := "--install-lib=${lib}"
endif

define list_modules
	`ls -1 | sed -n '/egg-info/n; /pyroute2/p'`
endef

define make_modules
	for module in $(call list_modules); do make -C $$module $(1) python=${python}; done
endef

define fetch_modules_dist
	for module in $(call list_modules); do cp $$module/dist/* dist; done
endef

define clean_module
	if [ -f $$module/setup.json ]; then \
		for i in `ls -1 templates`; do rm -f $$module/$$i; done; \
	fi; \
	rm -f $$module/LICENSE.*; \
	rm -f $$module/README.license.md; \
	rm -f $$module/CHANGELOG.md; \
	rm -f $$module/VERSION; \
	rm -rf $$module/build; \
	rm -rf $$module/dist; \
	rm -rf $$module/*egg-info
endef

define process_templates
	for module in $(call list_modules); do \
		if [ -f $$module/setup.json ]; then \
			for template in `ls -1 templates`; do \
				${python} \
					util/process_template.py \
					templates/$$template \
					$$module/setup.json \
					$$module/$$template; \
			done; \
		fi; \
	done
endef

define deploy_license
	cp LICENSE.* $$module/ ; \
	cp README.license.md $$module/ ; \
	cp CHANGELOG.md $$module/
endef

all:
	@echo targets:
	@echo
	@echo \* clean -- clean all generated files
	@echo \* docs -- generate project docs \(requires sphinx\)
	@echo \* test -- run functional tests \(see README.make.md\)
	@echo \* install -- install lib into the system
	@echo

clean:
	@for module in $(call list_modules); do $(call clean_module); done
	@rm -f VERSION
	@rm -rf dist build MANIFEST
	@rm -f docs-build.log
	@rm -f docs/general.rst
	@rm -f docs/changelog.rst
	@rm -f docs/makefile.rst
	@rm -f docs/report.rst
	@rm -rf docs/api
	@rm -rf docs/html
	@rm -rf docs/doctrees
	@[ -z "${keep_coverage}" ] && rm -f  tests/.coverage ||:
	@rm -rf tests/htmlcov
	@[ -z "${keep_coverage}" ] && rm -rf tests/cover ||:
	@rm -rf tests/examples
	@rm -rf tests/bin
	@rm -rf tests/pyroute2
	@rm -f  tests/*xml
	@rm -f  tests/tests.json
	@rm -f  tests/tests.log
	@rm -rf pyroute2.egg-info
	@rm -rf tests-workspaces
	@rm -f python-pyroute2.spec
	@rm -f pyroute2/config/version.py
	@rm -f pyroute2/config.json
	@rm -f pyroute2/setup.cfg
	@rm -f pyroute2.minimal/config.json
	@rm -f pyroute2.minimal/setup.cfg
	@find pyroute2 -name "*pyc" -exec rm -f "{}" \;
	@find pyroute2 -name "*pyo" -exec rm -f "{}" \;

VERSION:
	@${python} util/update_version.py
	@for package in $(call list_modules); do cp VERSION $$package; done
	@for package in pyroute2 pyroute2.minimal; do \
		echo '{"version": "'`cat $$package/VERSION`'"}' >$$package/config.json; \
	done

docs/html:
	@cp README.rst docs/general.rst
	@cp README.make.md docs/makefile.rst
	@cp README.report.md docs/report.rst
	@cp CHANGELOG.md docs/changelog.rst
	@[ -f docs/_templates/private.layout.html ] && ( \
	    mv -f docs/_templates/layout.html docs/_templates/layout.html.orig; \
		cp docs/_templates/private.layout.html docs/_templates/layout.html; ) ||:
	@export PYTHONPATH=`pwd`; \
		make -C docs html || export FAIL=true ; \
		[ -f docs/_templates/layout.html.orig ] && ( \
			mv -f docs/_templates/layout.html.orig docs/_templates/layout.html; ) ||: ;\
		unset PYTHONPATH ;\
		[ -z "$$FAIL" ] || false

docs: install docs/html

check_parameters:
	@if [ ! -z "${skip_tests}" ]; then \
		echo "'skip_tests' is deprecated, use 'skip=...' instead"; false; fi

format:
	@black -C -S -l 79 --extend-exclude setup.py pyroute2* examples tests/pytest

test-format:
	@black -C -S -l 79 --extend-exclude setup.py --check pyroute2* examples tests/pytest

test: check_parameters
	@export PYTHON=${python}; \
		export NOSE=${nosetests}; \
		export FLAKE8=${flake8}; \
		export WLEVEL=${wlevel}; \
		export SKIP_TESTS=${skip}; \
		export PDB=${pdb}; \
		export COVERAGE=${coverage}; \
		export MODULE=${module}; \
		export LOOP=${loop}; \
		export REPORT=${report}; \
		export WORKER=${worker}; \
		export WORKSPACE=${workspace}; \
		./tests/run.sh

pytest: check_parameters test-format
	@export PYTHON=${python}; \
		export PYTEST=${pytest}; \
		export FLAKE8=${flake8}; \
		export WLEVEL=${wlevel}; \
		export SKIP_TESTS=${skip}; \
		export PDB=${pdb}; \
		export COVERAGE=${coverage}; \
		export MODULE=${module}; \
		export LOOP=${loop}; \
		export REPORT=${report}; \
		export WORKER=${worker}; \
		export WORKSPACE=${workspace}; \
		export PYROUTE2_TEST_DBNAME=${dbname}; \
		export SKIPDB=${skipdb}; \
		./tests/run_pytest.sh

test-platform:
	@${python} -c "\
import logging;\
logging.basicConfig();\
from pr2modules.config.test_platform import TestCapsRtnl;\
from pprint import pprint;\
pprint(TestCapsRtnl().collect())"

upload: dist
	${python} -m twine upload dist/*

setup:
	$(call process_templates)
	@for module in $(call list_modules); do $(call deploy_license); done
	@for module in pyroute2 pyroute2.minimal; do \
		${python} \
		    util/process_template.py \
			$$module/setup.cfg.in \
			$$module/config.json \
			$$module/setup.cfg ; \
	done

dist: clean VERSION setup
	cd pyroute2; ${python} setup.py sdist
	mkdir dist
	$(call make_modules, dist)
	$(call fetch_modules_dist)
	${python} -m twine check dist/*

install: dist
	rm -f dist/pyroute2.minimal*
	${python} -m pip install dist/* ${root}

install-minimal: dist
	${python} -m pip install dist/pyroute2.minimal* dist/pyroute2.core* ${root}

uninstall: clean VERSION setup
	$(call make_modules, uninstall)

audit-imports:
	for module in $(call list_modules); do \
		echo $$module; \
		findimports -n $$module/pr2modules/ 2>/dev/null | awk -f util/imports_dict.awk | awk '{printf("\t"$$0"\n")}'; \
	done

# deprecated:
epydoc clean-version update-version force-version README.md setup.ini develop:
	@echo Deprecated target, see README.make.md

=== tests/requirements.txt ===
black
twine
aafigure
flake8
nose
coverage
eventlet
mitogen
bottle
sphinx
netaddr
psutil
pytest
pytest-cov
psycopg2
findimports

=== debian/changelog ===
pyroute2 (0.6.7-4~bpo11+1) bullseye-backports; urgency=medium

  * bullseye-backports Rebuilt for bullseye.

 -- Thomas Goirand <zigo@debian.org>  Wed, 12 Nov 2025 11:07:45 +0000

pyroute2 (0.6.7-4) UNRELEASED; urgency=medium

  * Add fix-pr2modules-to-allow-more-kernel-versions.patch.

 -- Thomas Goirand <zigo@debian.org>  Wed, 12 Nov 2025 11:07:34 +0000

pyroute2 (0.6.7-3) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Wed, 23 Mar 2022 16:01:24 +0100

pyroute2 (0.6.7-2) experimental; urgency=medium

  * Add (= ${binary:Version}) in inter-dependencies of resulting binaries.

 -- Thomas Goirand <zigo@debian.org>  Fri, 11 Mar 2022 00:20:52 +0100

pyroute2 (0.6.7-1) experimental; urgency=medium

  * New upstream release.

 -- Thomas Goirand <zigo@debian.org>  Thu, 10 Mar 2022 16:01:48 +0100

pyroute2 (0.6.6-1) experimental; urgency=medium

  * New upstream release.
  * Removed fix-conf.py-for-sphinx-4.patch applied upstream.

 -- Thomas Goirand <zigo@debian.org>  Mon, 21 Feb 2022 09:22:08 +0100

=== debian/control ===
Source: pyroute2
Section: python
Priority: optional
Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
 Florian Pelgrim <florian.pelgrim@craneworks.de>,
Build-Depends:
 debhelper-compat (= 12),
 dh-python,
 openstack-pkg-tools,
 python3-all,
 python3-setuptools,
Build-Depends-Indep:
 python3-aafigure,
 python3-bottle,
 python3-coverage,
 python3-eventlet,
 python3-mitogen,
 python3-netaddr,
 python3-nose,
 python3-psutil,
 python3-psycopg2,
 python3-pytest,
 python3-pytest-cov,
 python3-sphinx,
Standards-Version: 4.5.0
VCS-Browser: https://salsa.debian.org/third-party/pyroute2
VCS-Git: https://salsa.debian.org/third-party/pyroute2.git
Homepage: https://github.com/svinota/pyroute2

Package: python-pyroute2-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: netlink and Linux network configuration library (documentation)
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 .
 This package contains the Python module documentation.

Package: python3-pyroute2
Architecture: all
Conflicts:
 python3-pyroute2-minimal,
Depends:
 python3-psutil,
 python3-pyroute2.core (= ${binary:Version}),
 python3-pyroute2.ethtool (= ${binary:Version}),
 python3-pyroute2.ipdb (= ${binary:Version}),
 python3-pyroute2.ipset (= ${binary:Version}),
 python3-pyroute2.ndb (= ${binary:Version}),
 python3-pyroute2.nftables (= ${binary:Version}),
 python3-pyroute2.nslink (= ${binary:Version}),
 python3-pyroute2.protocols (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: Python3 Netlink library - full package
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package depends on all packages making Pyroute 2. install this
 if you want the full distribution of Pyroute 2.

Package: python3-pyroute2-minimal
Architecture: all
Conflicts:
 python3-pyroute2,
 python3-pyroute2.ethtool,
 python3-pyroute2.ipdb,
 python3-pyroute2.ipset,
 python3-pyroute2.ndb,
 python3-pyroute2.nftables,
 python3-pyroute2.nslink,
 python3-pyroute2.protocols,
Depends:
 python3-pyroute2.core (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Suggests:
 python-pyroute2-doc,
Description: Python3 Netlink library - minimal
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package provides a minimal installation of Pyroute 2.

Package: python3-pyroute2.core
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
Breaks:
 python3-pyroute2 (<< 0.6),
Replaces:
 python3-pyroute2 (<< 0.6),
Description: Python3 Netlink library - core
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package contains the core module of Pyroute 2.

Package: python3-pyroute2.ethtool
Architecture: all
Depends:
 python3-pyroute2.core (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: Python3 Netlink library - ethtool
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package contains the ethtool module of Pyroute 2.

Package: python3-pyroute2.ipdb
Architecture: all
Depends:
 python3-pyroute2.core (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: Python3 Netlink library - ipdb
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package contains the ipdb module of Pyroute 2.

Package: python3-pyroute2.ipset
Architecture: all
Depends:
 python3-pyroute2.core (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: Python3 Netlink library - ipset
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package contains the ipset module of Pyroute 2.

Package: python3-pyroute2.ndb
Architecture: all
Depends:
 python3-pyroute2.core (= ${binary:Version}),
 python3-pyroute2.nslink (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Breaks:
 python3-pyroute2 (<< 0.6),
Replaces:
 python3-pyroute2 (<< 0.6),
Description: Python3 Netlink library - ndb
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package contains the ndb module of Pyroute 2.

Package: python3-pyroute2.nftables
Architecture: all
Depends:
 python3-pyroute2.core (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: Python3 Netlink library - nftables
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package contains the nftables module of Pyroute 2.

Package: python3-pyroute2.nslink
Architecture: all
Depends:
 python3-pyroute2.core (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: Python3 Netlink library - nslink
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package contains the nslink module of Pyroute 2.

Package: python3-pyroute2.protocols
Architecture: all
Depends:
 python3-pyroute2.core (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: Python3 Netlink library - protocols
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package contains the protocols module of Pyroute 2.

## pyroute2 0.7.2

=== Makefile ===
##
#
#   The pyroute2 project is dual licensed, see README.license.md for details
#
#
python ?= $(shell util/find_python.sh)

.PHONY: all
all:
	@echo targets:
	@echo
	@echo \* clean -- clean all generated files
	@echo \* docs -- generate project docs
	@echo \* dist -- create the package file
	@echo \* test -- run all the tests
	@echo \* install -- install lib into the system or the current virtualenv
	@echo \* uninstall -- uninstall lib
	@echo

.PHONY: clean
clean:
	@$(MAKE) -C lab clean
	@$(MAKE) -C docs clean
	@rm -f lab/*html
	@rm -f lab/_static/conf.js
	@rm -rf dist build MANIFEST
	@rm -f docs-build.log
	@rm -rf pyroute2.egg-info
	@find pyroute2 -name "*pyc" -exec rm -f "{}" \;
	@find pyroute2 -name "*pyo" -exec rm -f "{}" \;
	@git checkout VERSION 2>/dev/null ||:

.PHONY: VERSION
VERSION:
	@${python} util/update_version.py

.PHONY: docs
docs:
	@nox -e docs

.PHONY: format
format:
	@nox -e linter

.PHONY: test
test:
	@nox

.PHONY: test-platform
test-platform:
	@nox -e test_platform

.PHONY: upload
upload: dist
	${python} -m twine upload dist/*

.PHONY: setup
setup:
	$(MAKE) VERSION

.PHONY: dist
dist: setup
	@nox -e build

.PHONY: dist-minimal
dist-minimal:
	mv -f setup.cfg setup.cfg.orig
	cp setup.minimal.cfg setup.cfg
	$(MAKE) dist
	mv -f setup.cfg.orig setup.cfg

.PHONY: install
install:
	$(MAKE) uninstall
	$(MAKE) clean
	$(MAKE) dist
	${python} -m pip install dist/pyroute2-*whl ${root}

.PHONY: install-minimal
install-minimal: dist-minimal
	${python} -m pip install dist/pyroute2.minimal*whl ${root}

.PHONY: uninstall
uninstall:
	${python} -m pip uninstall -y pyroute2
	${python} -m pip uninstall -y pyroute2-minimal

.PHONY: audit-imports
audit-imports:
	findimports -n pyroute2 2>/dev/null | awk -f util/imports_dict.awk

.PHONY: nox
nox:
	${python} -m venv .venv
	bash -c "source .venv/bin/activate; \
		python -m pip install --upgrade pip; \
		python -m pip install nox; \
		nox -e ${session}"

=== debian/changelog ===
pyroute2 (0.7.2-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Thu, 22 Sep 2022 16:46:52 +0200

pyroute2 (0.7.2-1) experimental; urgency=medium

  * New upstream release.
  * Upstream is back to a single package: Debian has to follow. Remove all
    separate binaries, add breaks+replaces+provides, and fix d/rules.
  * Run tests using nox, remove b-d on nose (Closes: #1018451).
  * Removed fix-upstream-way-to-find-version.patch and replaced it with a hack
    in d/rules.
  * Switch to pybuild and poetry packaging.
  * Add fix-path-to-links.dump.patch.
  * Package CHANGELOG.rst not CHANGELOG.md.

 -- Thomas Goirand <zigo@debian.org>  Wed, 31 Aug 2022 11:32:52 +0200

=== debian/control ===
Source: pyroute2
Section: python
Priority: optional
Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
 Florian Pelgrim <florian.pelgrim@craneworks.de>,
Build-Depends:
 debhelper-compat (= 12),
 dh-python,
 openstack-pkg-tools,
 pybuild-plugin-pyproject,
 python3-all,
 python3-poetry-core,
 python3-setuptools,
Build-Depends-Indep:
 iproute2,
 python3-aafigure,
 python3-bottle,
 python3-coverage,
 python3-eventlet,
 python3-mitogen,
 python3-netaddr,
 python3-nox,
 python3-psutil,
 python3-psycopg2,
 python3-pytest,
 python3-pytest-cov,
 python3-sphinx,
Standards-Version: 4.5.0
VCS-Browser: https://salsa.debian.org/third-party/pyroute2
VCS-Git: https://salsa.debian.org/third-party/pyroute2.git
Homepage: https://github.com/svinota/pyroute2

Package: python-pyroute2-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: netlink and Linux network configuration library (documentation)
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 .
 This package contains the Python module documentation.

Package: python3-pyroute2
Architecture: all
Breaks:
 python3-pyroute2-minimal,
 python3-pyroute2.core,
 python3-pyroute2.ethtool,
 python3-pyroute2.ipdb,
 python3-pyroute2.ipset,
 python3-pyroute2.ndb,
 python3-pyroute2.nftables,
 python3-pyroute2.nslink,
 python3-pyroute2.protocols,
Replaces:
 python3-pyroute2-minimal,
 python3-pyroute2.core,
 python3-pyroute2.ethtool,
 python3-pyroute2.ipdb,
 python3-pyroute2.ipset,
 python3-pyroute2.ndb,
 python3-pyroute2.nftables,
 python3-pyroute2.nslink,
 python3-pyroute2.protocols,
Provides:
 python3-pyroute2-minimal,
 python3-pyroute2.core,
 python3-pyroute2.ethtool,
 python3-pyroute2.ipdb,
 python3-pyroute2.ipset,
 python3-pyroute2.ndb,
 python3-pyroute2.nftables,
 python3-pyroute2.nslink,
 python3-pyroute2.protocols,
Depends:
 python3-psutil,
 ${misc:Depends},
 ${python3:Depends},
Description: Python3 Netlink library - full package
 Pyroute2 is a pure Python netlink and Linux network configuration
 library. It requires only Python stdlib, no 3rd party libraries.
 Later it can change, but the deps tree will remain as simple, as
 it is possible.
 .
 This package depends on all packages making Pyroute 2. install this
 if you want the full distribution of Pyroute 2.

=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_GIT := https://github.com/svinota/pyroute2
include /usr/share/openstack-pkg-tools/pkgos.make

export PYBUILD_NAME=pyroute2
export python=python3

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	echo "No tests for now..."
#	ip -json link >$(CURDIR)/tests/test_unit/test_iproute_match/links.dump
#	set -e ; set -x ; for pyvers in $(PYTHON3S) ; do \
#		python$$pyvers -m pytest tests/test_unit -v ; \
#	done
endif

override_dh_auto_build:
	echo $$OSLO_PACKAGE_VERSION > VERSION
	dh_auto_build

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.rst

override_dh_sphinxdoc:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	PYTHONPATH=$(CURDIR)/debian/test-installs/usr/lib/python3/dist-packages python3 -m sphinx -b html docs $(CURDIR)/debian/python-pyroute2-doc/usr/share/doc/python-pyroute2-doc/html
	dh_sphinxdoc
endif

## pyroute2 0.7.3

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,14 @@
 #
 #
 python ?= $(shell util/find_python.sh)
+
+define nox
+	[ -d .venv ] || ${python} -m venv .venv
+	bash -c "source .venv/bin/activate; \
+		python -m pip install --upgrade pip; \
+		python -m pip install nox; \
+		nox $(1)"
+endef
 
 .PHONY: all
 all:
@@ -19,10 +27,11 @@
 
 .PHONY: clean
 clean:
-	@$(MAKE) -C lab clean
-	@$(MAKE) -C docs clean
 	@rm -f lab/*html
 	@rm -f lab/_static/conf.js
+	@rm -rf lab/_build
+	@rm -rf docs/html
+	@rm -rf docs/man
 	@rm -rf dist build MANIFEST
 	@rm -f docs-build.log
 	@rm -rf pyroute2.egg-info
@@ -36,19 +45,19 @@
 
 .PHONY: docs
 docs:
-	@nox -e docs
+	$(call nox,-e docs)
 
 .PHONY: format
 format:
-	@nox -e linter
+	$(call nox,-e linter)
 
 .PHONY: test
 test:
-	@nox
+	$(call nox,)
 
 .PHONY: test-platform
 test-platform:
-	@nox -e test_platform
+	$(call nox,-e test_platform)
 
 .PHONY: upload
 upload: dist
@@ -60,20 +69,20 @@
 
 .PHONY: dist
 dist: setup
-	@nox -e build
+	$(call nox,-e build)
 
 .PHONY: dist-minimal
-dist-minimal:
+dist-minimal: setup
 	mv -f setup.cfg setup.cfg.orig
 	cp setup.minimal.cfg setup.cfg
-	$(MAKE) dist
+	$(call nox,-e build)
 	mv -f setup.cfg.orig setup.cfg
 
 .PHONY: install
-install:
+install: setup
 	$(MAKE) uninstall
 	$(MAKE) clean
-	$(MAKE) dist
+	$(call nox,-e build)
 	${python} -m pip install dist/pyroute2-*whl ${root}
 
 .PHONY: install-minimal
@@ -91,8 +100,4 @@
 
 .PHONY: nox
 nox:
-	${python} -m venv .venv
-	bash -c "source .venv/bin/activate; \
-		python -m pip install --upgrade pip; \
-		python -m pip install nox; \
-		nox -e ${session}"
+	$(call nox,-e ${session})

=== debian/changelog ===
pyroute2 (0.7.3-4~cloud0) jammy-bobcat; urgency=medium

  * New update for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Tue, 22 Aug 2023 18:14:05 +0000

pyroute2 (0.7.3-4) unstable; urgency=medium

  * Cleans better (Closes: #1048854).

 -- Thomas Goirand <zigo@debian.org>  Tue, 22 Aug 2023 12:21:24 +0200

pyroute2 (0.7.3-3) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Mon, 19 Jun 2023 10:01:07 +0200

pyroute2 (0.7.3-2) experimental; urgency=medium

  * Fix VCS URLs.

 -- Thomas Goirand <zigo@debian.org>  Thu, 02 Mar 2023 17:00:03 +0100

pyroute2 (0.7.3-1) experimental; urgency=medium

  * New upstream release.
  * Add python3-sphinx-code-include as build-depends.

 -- Thomas Goirand <zigo@debian.org>  Thu, 02 Mar 2023 13:51:13 +0100

## pyroute2 0.7.7

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	bash -c "source .venv/bin/activate; \
 		python -m pip install --upgrade pip; \
 		python -m pip install nox; \
-		nox $(1)"
+		nox $(1) -- '$(subst ",\",${noxconfig})'"
 endef
 
 .PHONY: all
@@ -24,6 +24,13 @@
 	@echo \* install -- install lib into the system or the current virtualenv
 	@echo \* uninstall -- uninstall lib
 	@echo
+
+.PHONY: git-clean
+git-clean:
+	git clean -d -f -x
+	git remote prune origin
+	git branch --merged >/tmp/merged-branches && \
+		vi /tmp/merged-branches && xargs git branch -d </tmp/merged-branches
 
 .PHONY: clean
 clean:
@@ -46,6 +53,10 @@
 .PHONY: docs
 docs:
 	$(call nox,-e docs)
+
+.PHONY: lab
+lab:
+	$(call nox,-e lab)
 
 .PHONY: format
 format:
@@ -73,10 +84,7 @@
 
 .PHONY: dist-minimal
 dist-minimal: setup
-	mv -f setup.cfg setup.cfg.orig
-	cp setup.minimal.cfg setup.cfg
-	$(call nox,-e build)
-	mv -f setup.cfg.orig setup.cfg
+	$(call nox,-e build_minimal)
 
 .PHONY: install
 install: setup

=== examples/generic/Makefile ===
obj-m += netl.o

all:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) modules

clean:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) clean

=== debian/changelog ===
pyroute2 (0.7.7-4) unstable; urgency=medium

  [ Nicolas Schier ]
  * Add test against unknown version
  * Fix pyroute2.__version__ to hold real version number (Closes: #1052606)

 -- Thomas Goirand <zigo@debian.org>  Thu, 22 Feb 2024 18:25:30 +0100

pyroute2 (0.7.7-3) unstable; urgency=medium

  * Fix VCS URL (Closes: #1052605).

 -- Thomas Goirand <zigo@debian.org>  Thu, 15 Feb 2024 21:48:42 +0100

pyroute2 (0.7.7-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Wed, 04 Oct 2023 21:20:24 +0200

pyroute2 (0.7.7-1) experimental; urgency=medium

  * New upstream rlease.

 -- Thomas Goirand <zigo@debian.org>  Thu, 14 Sep 2023 11:22:42 +0200

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,12 @@
 
 %:
 	dh $@ --with python3,sphinxdoc --buildsystem=pybuild
+
+override_dh_auto_clean:
+	rm -rf build .stestr *.egg-info .pybuild
+	find . -iname '*.pyc' -delete
+	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done
+	rm -f pyroute2/config/version.py
 
 override_dh_auto_test:
 ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
@@ -20,6 +26,7 @@
 
 override_dh_auto_build:
 	echo $$OSLO_PACKAGE_VERSION > VERSION
+	$(MAKE) VERSION
 	dh_auto_build
 
 override_dh_installchangelogs:

=== debian/tests/control ===
Tests:
 version-is-not-unknown
Restrictions:
 superficial

## pyroute2 0.7.11

=== Makefile ===
--- 
+++ 
@@ -6,11 +6,7 @@
 python ?= $(shell util/find_python.sh)
 
 define nox
-	[ -d .venv ] || ${python} -m venv .venv
-	bash -c "source .venv/bin/activate; \
-		python -m pip install --upgrade pip; \
-		python -m pip install nox; \
-		nox $(1) -- '$(subst ",\",${noxconfig})'"
+	nox $(1) -- '$(subst ",\",${noxconfig})'
 endef
 
 .PHONY: all
@@ -72,7 +68,7 @@
 
 .PHONY: upload
 upload: dist
-	${python} -m twine upload dist/*
+	$(call nox,-e upload)
 
 .PHONY: setup
 setup:

=== debian/changelog ===
pyroute2 (0.7.11-0ubuntu2) noble; urgency=medium

  * debian/control: drop Build-Depends-Indep: python3-mitogen
    This allows us to temporarily remove python-mitogen from 
    the archive (LP: #2053266)

 -- Nick Rosbrook <enr0n@ubuntu.com>  Thu, 15 Feb 2024 12:14:40 -0500

pyroute2 (0.7.11-0ubuntu1) noble; urgency=medium

  * d/watch: Update to use github+tags for new releases otherwise doc
    build fails.
  * New upstream point release.

 -- James Page <james.page@ubuntu.com>  Fri, 09 Feb 2024 09:54:26 +0000

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,6 @@
 	rm -rf build .stestr *.egg-info .pybuild
 	find . -iname '*.pyc' -delete
 	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done
-	rm -f pyroute2/config/version.py
 
 override_dh_auto_test:
 ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
@@ -26,7 +25,6 @@
 
 override_dh_auto_build:
 	echo $$OSLO_PACKAGE_VERSION > VERSION
-	$(MAKE) VERSION
 	dh_auto_build
 
 override_dh_installchangelogs:

=== debian/watch ===
version=3
opts="uversionmangle=s/\.(b|rc)/~$1/" \
https://github.com/svinota/pyroute2/tags .*/(\d[\d\.]+)\.tar\.gz

## pyroute2 0.8.1

=== Makefile ===
--- 
+++ 
@@ -4,9 +4,20 @@
 #
 #
 python ?= $(shell util/find_python.sh)
+platform := $(shell uname -s)
+releaseTag ?= $(shell git describe --tags --abbrev=0)
+releaseDescription := $(shell git tag -l -n1 ${releaseTag} | sed 's/[0-9. ]\+//')
 
 define nox
-	nox $(1) -- '$(subst ",\",${noxconfig})'
+        {\
+		which nox 2>/dev/null || {\
+			${python} -m venv ~/.venv-boot/;\
+			. ~/.venv-boot/bin/activate;\
+			pip install --upgrade pip;\
+			pip install nox;\
+		};\
+		nox $(1) -- '${noxconfig}';\
+	}
 endef
 
 .PHONY: all
@@ -25,8 +36,8 @@
 git-clean:
 	git clean -d -f -x
 	git remote prune origin
-	git branch --merged >/tmp/merged-branches && \
-		vi /tmp/merged-branches && xargs git branch -d </tmp/merged-branches
+	git branch --merged | grep -vE '(^\*| master )' >/tmp/merged-branches && \
+		( xargs git branch -d </tmp/merged-branches ) ||:
 
 .PHONY: clean
 clean:
@@ -60,7 +71,13 @@
 
 .PHONY: test
 test:
+ifeq ($(platform), Linux)
 	$(call nox,)
+else ifeq ($(platform), OpenBSD)
+	$(call nox,-e openbsd)
+else
+	$(info >> Platform not supported)
+endif
 
 .PHONY: test-platform
 test-platform:
@@ -69,6 +86,14 @@
 .PHONY: upload
 upload: dist
 	$(call nox,-e upload)
+
+.PHONY: release
+release: dist
+	gh release create \
+		--verify-tag \
+		--title "${releaseDescription}" \
+		${releaseTag} \
+		./dist/*${releaseTag}*
 
 .PHONY: setup
 setup:

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = .

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/html
	-rm -rf $(BUILDDIR)/man

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/pyroute2.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/pyroute2.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/pyroute2"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/pyroute2"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
pyroute2 (0.8.1-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Sun, 28 Sep 2025 11:50:25 +0200

pyroute2 (0.8.1-1) experimental; urgency=medium

  * New upstream release.
  * Add build-time tests and autopkgtest.

 -- Thomas Goirand <zigo@debian.org>  Wed, 27 Aug 2025 12:43:02 +0200

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
  python3-all,
  python3-poetry-core,
  python3-setuptools,
+ python3-sphinx-code-include,
 Build-Depends-Indep:
  iproute2,
  python3-aafigure,
@@ -28,8 +29,8 @@
  python3-pytest-cov,
  python3-sphinx,
 Standards-Version: 4.5.0
-VCS-Browser: https://salsa.debian.org/third-party/pyroute2
-VCS-Git: https://salsa.debian.org/third-party/pyroute2.git
+VCS-Browser: https://salsa.debian.org/openstack-team/third-party/pyroute2
+VCS-Git: https://salsa.debian.org/openstack-team/third-party/pyroute2.git
 Homepage: https://github.com/svinota/pyroute2
 
 Package: python-pyroute2-doc

=== debian/rules ===
--- 
+++ 
@@ -13,18 +13,22 @@
 	rm -rf build .stestr *.egg-info .pybuild
 	find . -iname '*.pyc' -delete
 	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done
+	rm -f pyroute2/config/version.py
+	rm -f test_unit
 
 override_dh_auto_test:
 ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
-	echo "No tests for now..."
 #	ip -json link >$(CURDIR)/tests/test_unit/test_iproute_match/links.dump
-#	set -e ; set -x ; for pyvers in $(PYTHON3S) ; do \
-#		python$$pyvers -m pytest tests/test_unit -v ; \
-#	done
+	ln -s tests/test_unit test_unit
+	set -e ; set -x ; for pyvers in $(PYTHON3S) ; do \
+		python$$pyvers -m pytest tests/test_unit -v ; \
+		python$$pyvers -m pytest tests/test_neutron -v ; \
+	done
 endif
 
 override_dh_auto_build:
 	echo $$OSLO_PACKAGE_VERSION > VERSION
+	$(MAKE) VERSION
 	dh_auto_build
 
 override_dh_installchangelogs:

=== debian/tests/control ===
Tests:
 version-is-not-unknown
Restrictions:
 superficial

Tests: unittests
Depends:
 @,
 @builddeps@,
Restrictions: allow-stderr needs-root
